> ## Documentation Index
> Fetch the complete documentation index at: https://kb.talostrading.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Protocols

> Returns a list of blockchain protocol metadata.



## OpenAPI

````yaml /coinmetrics/openapi/coinmetrics.yaml get /reference-data/protocols
openapi: 3.0.2
info:
  title: Coin Metrics API v4
  description: >-
    [Coin Metrics Homepage](https://coinmetrics.io/)<br/> [API Backward
    Compatibility
    Policy](https://docs.coinmetrics.io/access-our-data/api#backward-compatibility)<br/>
    [Python API
    Client](https://coinmetrics.github.io/api-client-python/site/index.html)<br/><br/>

    HTTP API root endpoint URL is `https://api.coinmetrics.io/v4`. Coin
    Metrics&apos; paid product.<br/> WebSocket API root endpoint is
    `wss://api.coinmetrics.io/v4`. Coin Metrics&apos; paid product.<br/><br/>
    The Community HTTP API root endpoint URL is
    `https://community-api.coinmetrics.io/v4`. API key is not required when
    accessing community endpoints. Available to the community under the
    [Creative Commons](https://creativecommons.org/licenses/by-nc/4.0/) license.

    # Authentication

    <!-- ReDoc-Inject: <security-definitions> -->

    # Response headers

    Note that Coin Metrics API responses have a `CF-RAY` HTTP header e.g.
    `88a6ec1d2f930774-IAD` which can be used for diagnostic purposes. When
    raising Support requests, please ensure to provide the value of this
    header. 
  termsOfService: https://coinmetrics.io/api/terms
  contact:
    name: Coin Metrics Support
    url: https://coinmetrics.io/support/
    email: support@coinmetrics.io
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html
  version: 4.0.0
servers:
  - url: https://api.coinmetrics.io/v4
  - url: wss://api.coinmetrics.io/v4
  - url: https://community-api.coinmetrics.io/v4
security: []
tags:
  - name: Rate limits
    description: >-
      To ensure the quality of Coin Metrics services, API is subject to rate
      limiting.<br/> <table> <tr><th>Rate Limit Plan</th><th>REST API: Requests
      per Second (sliding window)</th><th>REST API: Download Speed</th><th>REST
      API: Max Parallel Requests</th><th>WebSocket API: Max Parallel
      Connections</th></tr> <tr><td>Community</td><td>10 requests per 6 seconds
      per IP address</td><td>Reduced speed</td><td>10</td><td>N/A</td></tr>
      <tr><td>Trial</td><td>10 requests per 6 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> <tr><td>Default (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Standard
      speed</td><td>10</td><td>200</td></tr> <tr><td>Download (PRO)</td><td>6000
      requests per 20 seconds per API key</td><td>Max
      speed</td><td>10</td><td>200</td></tr> </table> <br/> All PRO keys by
      default get the "default" rate limits. To download historical data at max
      speed, you need to switch to the "download" plan. <br/> <br/> The paid and
      community versions of the API have a limit of 10 parallel REST API
      requests. After this limit is reached, further parallel requests will be
      queued, so performance will be slower.<br/> <br/> If you reach the
      request-per-second limit, API starts to return `429 Too Many Requests`
      HTTP response status.<br/> API also provides `X-RateLimit-*` response
      headers formatted according to
      https://tools.ietf.org/html/draft-polli-ratelimit-headers-03.<br/>
      Additionally, the API provides the `X-RateLimit-Plan` header which
      indicates the current rate limiting plan. This header may have values:
      `default`, `trial`, `download`, or `community`.
    x-cm-gitbook:
      foldIntoInfo: true
  - name: Reference Data
    description: Metadata information of entities supported by Coin Metrics.
    x-cm-gitbook:
      tag: Meta Data
      icon: book
  - name: Catalog
    x-displayName: Catalog (deprecated)
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full
      catalog](#tag/Full-catalog) endpoints for the full list of supported by
      Coin Metrics data. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Catalog v2
    description: >-
      Catalog of available for your `api_key` data.<br/> Use the [Full catalog
      V2](#tag/Full-catalog-v2) endpoints for the full list of supported by Coin
      Metrics data.
    x-cm-gitbook:
      icon: list-check
  - name: Full catalog
    x-displayName: Full catalog (deprecated)
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog) endpoint. <br/>DEPRECATED: See
      https://coinmetrics.io/important-changes-to-coin-metrics-api-catalog-endpoints/.
    x-cm-gitbook:
      remove: true
  - name: Full catalog v2
    description: >-
      The Full catalog returns the full range of data that is supported by Coin
      Metrics across all our products.<br/> If you are a client looking to
      understand the data that is available for your API key and data license,
      please use the [Catalog](#tag/Catalog-v2) endpoint.
    x-cm-gitbook:
      tag: Catalog v2
      icon: layer-group
  - name: Timeseries
    description: >-
      Endpoints for fetching metrics, market data, indexes and other time series
      data.
    x-cm-gitbook:
      icon: chart-line
      renameOperationsTo: Timeseries REST
  - name: Timeseries stream
    description: >-
      WebSocket endpoints for getting a real-time stream of metrics, market
      data, indexes and other time series data.
    x-cm-gitbook:
      tag: Timeseries
      icon: wifi
  - name: Taxonomy
    description: Taxonomy endpoints
    x-cm-gitbook:
      icon: sitemap
  - name: Taxonomy Metadata
    description: Taxonomy Metadata endpoints
    x-cm-gitbook:
      tag: Taxonomy
      icon: tags
  - name: Profile
    description: Profile endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: id-card
  - name: List of blockchain entities v2
    description: Endpoints for fetching lists of blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: list
  - name: Full blockchain entities v2
    description: Endpoints for fetching full blockchain entities.
    x-cm-gitbook:
      tag: List of blockchain entities v2
      icon: database
  - name: Jobs
    description: Jobs API endpoints
    x-cm-gitbook:
      tag: ATLAS
      icon: briefcase
  - name: Blockchain Explorer Job
    description: Endpoints for creating async jobs for blockchain entities.
    x-cm-gitbook:
      tag: ATLAS
      icon: clock
  - name: Blockchain Explorer Job Results
    description: Schema definitions of results of Blockchain Explorer Job endpoints.
    x-cm-gitbook:
      foldInto: Blockchain Explorer Job
  - name: Chain Monitor tools
    description: Endpoints for working with chain monitor data.
    x-cm-gitbook:
      tag: ATLAS
      icon: wrench
  - name: Security Master
    description: Security Master endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: shield
  - name: Constituent Snapshots
    description: Endpoints for getting the snapshots of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: camera
  - name: Constituent Timeframes
    description: Endpoints for getting the timeframes of various constituents
    x-cm-gitbook:
      tag: Meta Data
      icon: calendar
  - name: Blockchain Metadata
    description: Blockchain metadata endpoints
    x-cm-gitbook:
      tag: Meta Data
      icon: database
  - name: Meta Data
    x-cm-gitbook:
      icon: database
  - name: ATLAS
    x-cm-gitbook:
      icon: map
  - name: Timeseries REST
    x-cm-gitbook:
      tag: Timeseries
      icon: table
paths:
  /reference-data/protocols:
    servers:
      - url: https://api.coinmetrics.io/v4
    get:
      tags:
        - Reference Data
      summary: Protocols
      description: Returns a list of blockchain protocol metadata.
      operationId: getReferenceDataProtocols
      parameters:
        - $ref: '#/components/parameters/Protocols'
        - $ref: '#/components/parameters/ProtocolChains'
        - $ref: '#/components/parameters/ProtocolMarkets'
        - $ref: '#/components/parameters/PageSize'
        - $ref: '#/components/parameters/PagingFromWithStartByDefault'
        - $ref: '#/components/parameters/NextPageToken'
        - $ref: '#/components/parameters/CatalogResponseFormat'
        - $ref: '#/components/parameters/Pretty'
      responses:
        '200':
          $ref: '#/components/responses/ReferenceDataProtocols'
        '400':
          $ref: '#/components/responses/ProtocolNotFound'
        '401':
          $ref: '#/components/responses/Unauthorized'
        '414':
          $ref: '#/components/responses/UriTooLong'
      security:
        - api_key: []
      x-codeSamples:
        - lang: Shell
          label: Shell
          source: >
            curl --compressed
            "https://api.coinmetrics.io/v4/reference-data/protocols?pretty=true&api_key=<your_key>"
        - lang: Python
          label: Python
          source: >
            import requests

            response =
            requests.get('https://api.coinmetrics.io/v4/reference-data/protocols?pretty=true&api_key=<your_key>').json()

            print(response)
components:
  parameters:
    Protocols:
      description: Comma separated list of protocols like `aave_v3` or `morpho_blue`.
      in: query
      name: protocols
      schema:
        type: array
        items:
          type: string
      explode: false
    ProtocolChains:
      description: Comma separated list of protocol chains like `ethereum` or `base`.
      in: query
      name: chains
      schema:
        type: array
        items:
          type: string
      explode: false
    ProtocolMarkets:
      description: >-
        Comma separated list of protocol markets like `core-weth` or
        `steakusdc`.
      in: query
      name: markets
      schema:
        type: array
        items:
          type: string
      explode: false
    PageSize:
      description: >-
        Number of items per single page of results.<br/> The value of this
        parameter is ignored if the endpoint supports the `format` parameter and
        its value is set to `json_stream`.
      in: query
      name: page_size
      schema:
        default: 100
        type: integer
        format: int32
        minimum: 1
        maximum: 10000
    PagingFromWithStartByDefault:
      description: >-
        Where does the first page start, at the start of the interval or at the
        end.<br/> The value of this parameter is ignored if the endpoint
        supports the `format` parameter and its value is set to `json_stream`.
      in: query
      name: paging_from
      schema:
        default: start
        enum:
          - start
          - end
        type: string
        format: PagingFrom
    NextPageToken:
      description: >-
        Token for receiving the results from the next page of a query.<br/>
        Should not be used directly. To iterate through pages just use
        `next_page_url` response field.
      in: query
      name: next_page_token
      schema:
        type: string
    CatalogResponseFormat:
      description: Format of the response. Supported values are `json`, `json_stream`.
      in: query
      name: format
      schema:
        type: string
        default: json
    Pretty:
      description: Human-readable formatting of JSON responses.
      in: query
      name: pretty
      schema:
        type: boolean
        default: false
  responses:
    ReferenceDataProtocols:
      description: Protocol metadata.
      content:
        application/json:
          example:
            data:
              - market: core-weth
                full_name: Core Aave Market Wrapped Ether
                protocol: aave_v3
                type: aave_pool
                chains:
                  - chain: ethereum
                    address: '0x87870bca3f3fd6335c3f4ce8392d69350b4fa4e2'
                    asset: weth
                    asset_address: '0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2'
                    asset_decimals: '18'
                    configurator_address: '0x64b761d848206f447fe2dd461b0c635ec39ebb27'
                    atoken_address: '0x4d5f47fa6a74757f35c14fd3a6ef8e3c9bc514e8'
                    atoken_asset: aethweth_v3_eth
                    variable_debt_token_address: '0xea51d7853eefb32b6ee06b1c12e6dcca88be0ffe'
                    variable_debt_asset: vethweth_v3_eth
                    stable_debt_token_address: '0x102633152313c81cd80419b6ecf66d14ad68949a'
              - market: prime-weth
                full_name: Prime Aave V4 Hub Market Wrapped Ether
                protocol: aave_hub_v4
                type: aave_hub_v4
                chains:
                  - chain: ethereum
                    address: '0x943827dca022d0f354a8a8c332da1e5eb9f9f931'
                    asset: weth
                    asset_address: '0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2'
                    asset_decimals: '18'
              - market: bluechip-prime-weth
                full_name: Bluechip Prime Aave V4 Market Wrapped Ether
                protocol: aave_spoke_v4
                type: aave_spoke_v4
                chains:
                  - chain: ethereum
                    address: '0x973a023a77420ba610f06b3858ad991df6d85a08'
                    asset: weth
                    asset_address: '0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2'
                    asset_decimals: '18'
                    hub_address: '0x943827dca022d0f354a8a8c332da1e5eb9f9f931'
                    irm_address: '0xda1266a7b8620819dae3f8bd6b546da36e505bb8'
              - market: steakusdc
                full_name: Steakhouse USDC
                protocol: morpho_blue
                type: morpho_vault
                chains:
                  - chain: ethereum
                    address: '0xbeef01735c132ada46aa9aa4c54623caa92a64cb'
                    asset: usdc
                    asset_address: '0xa0b86991c6218b36c1d19d4a2e9eb0ce3606eb48'
                    asset_decimals: '6'
          schema:
            $ref: '#/components/schemas/ReferenceDataProtocolsResponse'
    ProtocolNotFound:
      content:
        application/json:
          example:
            error:
              type: bad_parameter
              message: Bad parameter 'protocols'. Value 'asdgwav' is not supported.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
      description: Protocol not found.
    Unauthorized:
      description: Requested resource requires authorization.
      content:
        application/json:
          examples:
            unauthorized:
              summary: Unauthorized error response.
              value:
                error:
                  type: unauthorized
                  message: Requested resource requires authorization.
            wrong_credentials:
              summary: Wrong credentials error response.
              value:
                error:
                  type: wrong_credentials
                  message: Supplied credentials are not valid.
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    UriTooLong:
      description: Provided URI is too long. It must not be greater than 10000 symbols.
  schemas:
    ReferenceDataProtocolsResponse:
      description: Blockchain protocol reference data response.
      properties:
        data:
          $ref: '#/components/schemas/ReferenceDataProtocols'
        next_page_token:
          $ref: '#/components/schemas/NextPageToken'
        next_page_url:
          $ref: '#/components/schemas/NextPageUrl'
        warning:
          $ref: '#/components/schemas/WarningObject'
      required:
        - data
      type: object
    ErrorResponse:
      properties:
        error:
          $ref: '#/components/schemas/ErrorObject'
      required:
        - error
      type: object
    ReferenceDataProtocols:
      type: array
      items:
        $ref: '#/components/schemas/ReferenceDataProtocol'
    NextPageToken:
      description: Token of the next page results for a given request.
      type: string
    NextPageUrl:
      description: URL of the next page results for a given request.
      type: string
    WarningObject:
      properties:
        type:
          description: Warning type string. Can be used for warning identification.
          type: string
        message:
          description: >-
            Human-friendly warning description. Do not use for warning
            identification in your code.
          type: string
      required:
        - type
        - message
      type: object
    ErrorObject:
      properties:
        type:
          description: Error type string. Can be used for error identification.
          type: string
        message:
          description: >-
            Human-friendly error description. Can be amended without prior
            notification. Do not use for error identification in your code.
          type: string
      required:
        - type
        - description
      type: object
    ReferenceDataProtocol:
      description: Protocol reference data response.
      properties:
        market:
          description: Protocol market.
          type: string
        full_name:
          description: Full human-readable name of the protocol market.
          type: string
        protocol:
          description: Protocol name.
          type: string
        type:
          description: Protocol type.
          type: string
        chains:
          type: array
          items:
            $ref: '#/components/schemas/ProtocolChain'
      required:
        - market
        - full_name
        - protocol
        - type
        - chains
      type: object
    ProtocolChain:
      description: Protocol chain.
      properties:
        chain:
          description: Protocol chain.
          type: string
        address:
          $ref: '#/components/schemas/ProtocolAddress'
          description: >
            Primary contract address for the protocol entity. Aave: lending
            pool. Morpho vault: vault contract. Morpho market: market ID.
        asset:
          $ref: '#/components/schemas/ProtocolAsset'
          description: >
            Primary asset. Aave: reserve/underlying asset. Morpho vault: deposit
            asset. Morpho market: loan asset.
        asset_address:
          $ref: '#/components/schemas/ProtocolAddress'
          description: Address of the primary asset token.
        hub_address:
          $ref: '#/components/schemas/ProtocolAddress'
          description: >
            Address of the hub a spoke draws liquidity from. Populated for
            `aave_spoke_v4` only; a hub's own address is in `address`.
        asset_decimals:
          description: Decimal conversion.
          type: string
        configurator_address:
          $ref: '#/components/schemas/ProtocolAddress'
        atoken_address:
          $ref: '#/components/schemas/ProtocolAddress'
        atoken_asset:
          $ref: '#/components/schemas/ProtocolAsset'
        variable_debt_token_address:
          $ref: '#/components/schemas/ProtocolAddress'
        variable_debt_asset:
          $ref: '#/components/schemas/ProtocolAsset'
        stable_debt_token_address:
          $ref: '#/components/schemas/ProtocolAddress'
        curator_address:
          $ref: '#/components/schemas/ProtocolAddress'
        curator_name:
          $ref: '#/components/schemas/ProtocolAddressName'
        guardian_address:
          $ref: '#/components/schemas/ProtocolAddress'
        guardian_name:
          $ref: '#/components/schemas/ProtocolAddressName'
        collateral_asset:
          $ref: '#/components/schemas/ProtocolAsset'
          description: Collateral asset posted by borrowers.
        collateral_asset_address:
          $ref: '#/components/schemas/ProtocolAddress'
        oracle_address:
          $ref: '#/components/schemas/ProtocolAddress'
          description: Price oracle contract for the market.
        irm_address:
          $ref: '#/components/schemas/ProtocolAddress'
          description: Interest rate model contract for the market.
        lltv:
          description: Liquidation loan-to-value ratio for the market.
          type: string
      required:
        - chain
      type: object
    ProtocolAddress:
      description: Address of the protocol contract.
      type: string
    ProtocolAsset:
      description: Protocol asset symbol.
      type: string
    ProtocolAddressName:
      description: Name associated with the address.
      type: string
  securitySchemes:
    api_key:
      description: Coin Metrics API key can be specified as `?api_key=` query parameter.
      in: query
      name: api_key
      type: apiKey

````